Recognize sparclet cpu.
[deliverable/binutils-gdb.git] / configure.in
1 ##############################################################################
2
3 ## This file is a shell script fragment that supplies the information
4 ## necessary to tailor a template configure script into the configure
5 ## script appropriate for this directory. For more information, check
6 ## any existing configure script.
7
8 ## Be warned, there are two types of configure.in files. There are those
9 ## used by Autoconf, which are macros which are expanded into a configure
10 ## script by autoconf. The other sort, of which this is one, is executed
11 ## by Cygnus configure.
12
13 ## For more information on these two systems, check out the documentation
14 ## for 'Autoconf' (autoconf.texi) and 'Configure' (configure.texi).
15
16 ##############################################################################
17
18 ### To add a new directory to the tree, first choose whether it is a target
19 ### or a host dependent tool. Then put it into the appropriate list
20 ### (library or tools, host or target), doing a dependency sort. For
21 ### example, gdb requires that byacc (or bison) be built first, so it is in
22 ### the ${host_tools} list after byacc and bison.
23
24
25 # these libraries are used by various programs built for the host environment
26 #
27 host_libs="mmalloc libiberty opcodes bfd readline gash tcl tk tclX"
28
29 if [ "${enable_gdbgui}" = "yes" ] ; then
30 host_libs="${host_libs} libgui"
31 fi
32
33 # these tools are built for the host environment
34 #
35 host_tools="texinfo byacc flex bison binutils ld gas gcc gdb make patch
36 prms send-pr gprof gdbtest tgas etc expect dejagnu sim
37 m4 autoconf ispell grep diff rcs cvs fileutils shellutils
38 textutils wdiff find emacs emacs19 uudecode hello tar gzip indent
39 recode release sed utils"
40
41
42 # these libraries are built for the target environment, and are built after
43 # the host libraries and the host tools (which may be a cross compiler)
44 #
45 target_libs="target-libiberty target-libgloss target-newlib target-libio target-librx target-libstdc++ target-libg++"
46
47
48 # these tools are built using the target libs, and are intended to run only
49 # in the target environment
50 #
51 # note: any program that *uses* libraries that are in the "target_libs"
52 # list belongs in this list. those programs are also very likely
53 # candidates for the "native_only" list which follows
54 #
55 target_tools="target-examples target-groff"
56
57 ################################################################################
58
59 ## These two lists are of directories that are to be removed from the
60 ## ${configdirs} list for either cross-compilations or for native-
61 ## compilations. For example, it doesn't make that much sense to
62 ## cross-compile Emacs, nor is it terribly useful to compile target-libiberty in
63 ## a native environment.
64
65 # directories to be built in the native environment only
66 #
67 native_only="autoconf cvs emacs emacs19 fileutils find grep gzip hello
68 indent ispell m4 rcs recode sed shellutils tar textutils gash
69 uudecode wdiff gprof target-groff"
70
71 # directories to be built in a cross environment only
72 #
73 cross_only="target-libiberty target-libgloss target-newlib"
74
75 ## All tools belong in one of the four categories, and are assigned above
76 ## We assign ${configdirs} this way to remove all embedded newlines. This
77 ## is important because configure will choke if they ever get through.
78 ## ${configdirs} is directories we build using the host tools.
79 ## ${target_configdirs} is directories we build using the target tools.
80 #
81 configdirs=`echo ${host_libs} ${host_tools}`
82 target_configdirs=`echo ${target_libs} ${target_tools}`
83
84 ################################################################################
85
86 srctrigger=move-if-change
87 srcname="gnu development package"
88
89 # This gets set non-empty for some net releases of packages.
90 appdirs=""
91
92 # per-host:
93
94 # Work in distributions that contain no compiler tools, like Autoconf.
95 if [ -d ${srcdir}/config ]; then
96 case "${host}" in
97 m68k-hp-hpux*) host_makefile_frag=config/mh-hp300 ;;
98 m68k-apollo-sysv*) host_makefile_frag=config/mh-apollo68 ;;
99 m68k-apollo-bsd*) host_makefile_frag=config/mh-a68bsd ;;
100 m88k-dg-dgux*) host_makefile_frag=config/mh-dgux ;;
101 m88k-harris-cxux*) host_makefile_frag=config/mh-cxux ;;
102 m88k-motorola-sysv*) host_makefile_frag=config/mh-delta88;;
103 mips*-dec-ultrix*) host_makefile_frag=config/mh-decstation ;;
104 mips*-sgi-irix[56]*) host_makefile_frag=config/mh-irix5 ;;
105 mips*-sgi-irix4*) host_makefile_frag=config/mh-irix4 ;;
106 mips*-sgi-irix3*) host_makefile_frag=config/mh-sysv ;;
107 mips*-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
108 mips*-*-sysv*) host_makefile_frag=config/mh-riscos ;;
109 i[345]86-ncr-sysv4.3) host_makefile_frag=config/mh-ncrsvr43 ;;
110 i[345]86-ncr-sysv4*) host_makefile_frag=config/mh-ncr3000 ;;
111 i[345]86-*-sco3.2v5*) host_makefile_frag=config/mh-sysv ;;
112 i[345]86-*-sco*) host_makefile_frag=config/mh-sco ;;
113 i[345]86-*-isc*) host_makefile_frag=config/mh-sysv ;;
114 i[345]86-*-linux*) host_makefile_frag=config/mh-linux ;;
115 i[345]86-*-solaris2*) host_makefile_frag=config/mh-sysv4 ;;
116 i[345]86-*-aix*) host_makefile_frag=config/mh-aix386 ;;
117 i[345]86-*-go32*) host_makefile_frag=config/mh-go32 ;;
118 vax-*-ultrix2*) host_makefile_frag=config/mh-vaxult2 ;;
119 *-*-solaris2*) host_makefile_frag=config/mh-solaris ;;
120 m68k-sun-sunos*) host_makefile_frag=config/mh-sun3 ;;
121 *-hp-hpux[78]*) host_makefile_frag=config/mh-hpux8 ;;
122 *-hp-hpux*) host_makefile_frag=config/mh-hpux ;;
123 *-*-hiux*) host_makefile_frag=config/mh-hpux ;;
124 rs6000-*-lynxos*) host_makefile_frag=config/mh-lynxrs6k ;;
125 *-*-lynxos*) host_makefile_frag=config/mh-lynxos ;;
126 *-*-sysv4*) host_makefile_frag=config/mh-sysv4 ;;
127 *-*-sysv*) host_makefile_frag=config/mh-sysv ;;
128 esac
129 fi
130
131 # See if we can extract a definition of CC from the fragment.
132 if [ -z "${CC}" ]; then
133 if [ -n "${host_makefile_frag}" -a -f "${srcdir}/${host_makefile_frag}" ]; then
134 xx=`sed -n -e 's/^[ ]*CC[ ]*=[ ]*\(.*\)$/\1/p' < ${srcdir}/${host_makefile_frag}`
135 if [ -n "${xx}" ] ; then
136 CC=$xx
137 fi
138 fi
139 fi
140
141 # The Solaris /usr/ucb/cc compiler does not appear to work.
142 case "${host}" in
143 sparc-sun-solaris2*)
144 if [ "`/usr/bin/which ${CC-cc}`" = "/usr/ucb/cc" ] ; then
145 could_use=
146 [ -d /opt/SUNWspro/bin ] && could_use="/opt/SUNWspro/bin"
147 if [ -d /opt/cygnus/bin ] ; then
148 if [ "$could_use" = "" ] ; then
149 could_use="/opt/cygnus/bin"
150 else
151 could_use="$could_use or /opt/cygnus/bin"
152 fi
153 fi
154 if [ "$could_use" = "" ] ; then
155 echo "Warning: compilation may fail because you're using"
156 echo "/usr/ucb/cc. You should change your PATH or CC "
157 echo "variable and rerun configure."
158 else
159 echo "Warning: compilation may fail because you're using"
160 echo "/usr/ucb/cc, when you should use the C compiler from"
161 echo "$could_use. You should change your"
162 echo "PATH or CC variable and rerun configure."
163 fi
164 fi
165 ;;
166 esac
167
168 # We default to --with-shared on platforms where -fpic is meaningless.
169 # Well, we don't yet, but we will.
170 if false && [ "${host}" = "${target}" ] && [ x${enable_shared} = x ]; then
171 case "${target}" in
172 alpha-dec-osf*) enable_shared=yes ;;
173 mips-sgi-irix5*) enable_shared=yes ;;
174 *) enable_shared=no ;;
175 esac
176 fi
177
178 if [ x${enable_shared} = xyes ]; then
179 waugh=
180 case "${host}" in
181 hppa*) waugh=config/mh-papic ;;
182 i[345]86-*) waugh=config/mh-x86pic ;;
183 *) waugh=config/mh-${host_cpu}pic ;;
184 esac
185 if [ -f ${srcdir}/${waugh} ]; then
186 if [ -n "${host_makefile_frag}" ] ; then
187 cat ${srcdir}/${host_makefile_frag} > mh-frag
188 cat ${srcdir}/${waugh} >> mh-frag
189 host_makefile_frag=mh-frag
190 else
191 host_makefile_frag=${waugh}
192 fi
193 fi
194 fi
195
196 # per-target:
197
198 case "${target}" in
199 v810*) target_makefile_frag=config/mt-v810 ;;
200 i[345]86-*-netware*) target_makefile_frag=config/mt-netware ;;
201 powerpc-*-netware*) target_makefile_frag=config/mt-netware ;;
202 esac
203
204 skipdirs=
205 gasdir=gas
206 use_gnu_ld=
207 use_gnu_as=
208
209 # some tools are so dependent upon X11 that if we're not building with X,
210 # it's not even worth trying to configure, much less build, that tool.
211
212 case ${with_x} in
213 yes | "") # the default value for this tree is that X11 is available
214 ;;
215 no)
216 skipdirs="${skipdirs} tk gash"
217 ;;
218 *)
219 echo "*** bad value \"${with_x}\" for -with-x flag; ignored" 1>&2
220 ;;
221 esac
222
223 # Some tools are only suitable for building in a "native" situation.
224 # Those are added when we have a host==target configuration. For cross
225 # toolchains, we add some directories that should only be useful in a
226 # cross-compiler.
227
228 is_cross_compiler=
229
230 if [ x"${host}" = x"${target}" ] ; then
231 # when doing a native toolchain, don't build the targets
232 # that are in the 'cross only' list
233 skipdirs="${skipdirs} ${cross_only}"
234 is_cross_compiler=no
235 target_subdir=.
236 else
237 # similarly, don't build the targets in the 'native only'
238 # list when building a cross compiler
239 skipdirs="${skipdirs} ${native_only}"
240 is_cross_compiler=yes
241 target_subdir=${target_alias}
242 if [ ! -d ${target_subdir} ] ; then
243 if mkdir ${target_subdir} ; then true
244 else
245 echo "'*** could not make ${PWD=`pwd`}/${target_subdir}" 1>&2
246 exit 1
247 fi
248 fi
249 fi
250
251 copy_dirs=
252
253 # Handle --with-headers=XXX. The contents of the named directory are
254 # copied to $(tooldir)/sys-include.
255 if [ x"${with_headers}" != x ]; then
256 if [ x${is_cross_compiler} = xno ]; then
257 echo 1>&2 '***' --with-headers is only supported when cross compiling
258 exit 1
259 fi
260 case "${exec_prefixoption}" in
261 "") x=${prefix} ;;
262 *) x=${exec_prefix} ;;
263 esac
264 copy_dirs="${copy_dirs} ${with_headers} $x/${target_alias}/sys-include"
265 fi
266
267 # Handle --with-libs=XXX. Multiple directories are permitted. The
268 # contents are copied to $(tooldir)/lib.
269 if [ x"${with_libs}" != x ]; then
270 if [ x${is_cross_compiler} = xno ]; then
271 echo 1>&2 '***' --with-libs is only supported when cross compiling
272 exit 1
273 fi
274 # Copy the libraries in reverse order, so that files in the first named
275 # library override files in subsequent libraries.
276 case "${exec_prefixoption}" in
277 "") x=${prefix} ;;
278 *) x=${exec_prefix} ;;
279 esac
280 for l in ${with_libs}; do
281 copy_dirs="$l $x/${target_alias}/lib ${copy_dirs}"
282 done
283 fi
284
285 # If both --with-headers and --with-libs are specified, default to
286 # --without-newlib.
287 if [ x"${with_headers}" != x ] && [ x"${with_libs}" != x ]; then
288 if [ x"${with_newlib}" = x ]; then
289 with_newlib=no
290 fi
291 fi
292
293 # Recognize --with-newlib/--without-newlib.
294 if [ x${with_newlib} = xno ]; then
295 skipdirs="${skipdirs} target-newlib"
296 elif [ x${with_newlib} = xyes ]; then
297 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
298 fi
299
300 # Default to using --with-stabs for certain targets.
301 if [ x${with_stabs} = x ]; then
302 case "${target}" in
303 mips*-*-* | alpha*-*-osf* | i[345]86*-*-sysv4* | i[345]86*-*-unixware*)
304 with_stabs=yes;
305 withoptions="${withoptions} --with-stabs"
306 ;;
307 esac
308 fi
309
310 # Handle ${copy_dirs}
311 set fnord ${copy_dirs}
312 shift
313 while [ $# != 0 ]; do
314 if [ -f $2/COPIED ] && [ x"`cat $2/COPIED`" = x"$1" ]; then
315 :
316 else
317 echo Copying $1 to $2
318
319 # Use the install script to create the directory and all required
320 # parent directories.
321 if [ -d $2 ]; then
322 :
323 else
324 echo >config.temp
325 ${srcdir}/install.sh -c -m 644 config.temp $2/COPIED
326 fi
327
328 # Copy the directory, assuming we have tar.
329 # FIXME: Should we use B in the second tar? Not all systems support it.
330 (cd $1; tar -cf - .) | (cd $2; tar -xpf -)
331
332 # It is the responsibility of the user to correctly adjust all
333 # symlinks. If somebody can figure out how to handle them correctly
334 # here, feel free to add the code.
335
336 echo $1 > $2/COPIED
337 fi
338 shift; shift
339 done
340
341 # Configure extra directories which are host specific
342
343 case "${host}" in
344 i[345]86-*-go32*)
345 configdirs="$configdirs dosrel" ;;
346 esac
347
348 # Remove more programs from consideration, based on the host or
349 # target this usually means that a port of the program doesn't
350 # exist yet.
351
352 noconfigdirs=""
353
354 case "${host}" in
355 i[345]86-*-vsta)
356 noconfigdirs="tcl expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
357 ;;
358 i[345]86-*-go32)
359 noconfigdirs="tcl tk expect dejagnu make texinfo bison patch flex byacc send-pr gprof uudecode dejagnu diff"
360 ;;
361 *-*-cygwin32)
362 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
363 ;;
364 ppc*-*-pe)
365 noconfigdirs="patch diff make tk tcl expect dejagnu cvs autoconf texinfo bison send-pr gprof rcs"
366 ;;
367 esac
368
369
370 case "${target}" in
371 *-*-netware)
372 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-librx target-newlib target-libiberty"
373 ;;
374 *-*-vxworks*)
375 noconfigdirs="$noconfigdirs target-newlib"
376 ;;
377 alpha-dec-osf*)
378 # ld works, but does not support shared libraries. emacs doesn't
379 # work. newlib is not 64 bit ready. I'm not sure about fileutils or grep.
380 # gas doesn't generate exception information.
381 noconfigdirs="$noconfigdirs gas ld emacs fileutils grep target-newlib"
382 ;;
383 alpha*-*-*)
384 # newlib is not 64 bit ready
385 noconfigdirs="$noconfigdirs target-newlib"
386 ;;
387 # start-sanitize-arc
388 arc-*-*)
389 ;;
390 # end-sanitize-arc
391 arm-*-pe*)
392 ;;
393 arm-*-riscix*)
394 noconfigdirs="$noconfigdirs ld"
395 ;;
396 h8300*-*-* | \
397 h8500-*-*)
398 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
399 ;;
400 hppa*-*-*elf* | \
401 hppa*-*-lites*)
402 # Do configure ld/binutils/gas for this case.
403 ;;
404 hppa*-*-*)
405 # HP's C compiler doesn't handle Emacs correctly (but on BSD and Mach
406 # cc is gcc, and on any system a user should be able to link cc to
407 # whatever they want. FIXME, emacs emacs19).
408 case "${CC}" in
409 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
410 *) ;;
411 esac
412 noconfigdirs="$noconfigdirs ld shellutils"
413 ;;
414 i[345]86-*-go32)
415 # but don't build gdb
416 noconfigdirs="$noconfigdirs gdb target-libg++ target-libstdc++ target-libio target-librx"
417 ;;
418 *-*-cygwin32)
419
420 # make/glob's configure uses some AC_TRY_RUN type tests
421 target_configdirs="$target_configdirs target-winsup"
422 noconfigdirs="$noconfigdirs tcl tk expect make"
423 # always build newlib.
424 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
425
426 # Can't build gdb for cygwin32 if not native.
427 case "${host}" in
428 *-*-cygwin32) ;; # keep gdb
429 *) noconfigdirs="$noconfigdirs gdb"
430 esac
431
432 ;;
433 i[345]86-*-pe)
434 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
435 ;;
436 i[345]86-*-sco3.2v5*)
437 # The linker does not yet know about weak symbols in COFF,
438 # and is not configured to handle mixed ELF and COFF.
439 noconfigdirs="$noconfigdirs gprof ld"
440 ;;
441 i[345]86-*-sco*)
442 noconfigdirs="$noconfigdirs gprof"
443 ;;
444 i[345]86-*-solaris2*)
445 # The linker does static linking correctly, but the Solaris C library
446 # has bugs such that some important functions won't work when statically
447 # linked. (See man pages for getpwuid, for example.)
448 noconfigdirs="$noconfigdirs ld"
449 ;;
450 i[345]86-*-sysv4*)
451 # The SYSV4 C compiler doesn't handle Emacs correctly
452 case "${CC}" in
453 "" | cc*) noconfigdirs="$noconfigdirs emacs emacs19" ;;
454 *) ;;
455 esac
456 # but that's okay since emacs doesn't work anyway
457 noconfigdirs="$noconfigdirs emacs emacs19"
458 ;;
459 powerpc-*-aix*)
460 # copied from rs6000-*-* entry
461 noconfigdirs="$noconfigdirs gprof cvs"
462 ;;
463 powerpc*-*-winnt* | powerpc*-*-pe* | ppc*-*-pe)
464 target_configdirs="$target_configdirs target-winsup"
465 noconfigdirs="$noconfigdirs gdb tcl tk make expect"
466 # always build newlib.
467 skipdirs=`echo " ${skipdirs} " | sed -e 's/ target-newlib / /'`
468 ;;
469 rs6000-*-lynxos*)
470 # The CVS server code doesn't work on the RS/6000
471 # Newlib makes problems for libg++ in crosses.
472 noconfigdirs="$noconfigdirs target-newlib gprof cvs"
473 ;;
474 rs6000-*-*)
475 noconfigdirs="$noconfigdirs gprof"
476 ;;
477 m68k-*-netbsd*)
478 noconfigdirs="$noconfigdirs gdb"
479 ;;
480 m68k-apollo-*)
481 noconfigdirs="$noconfigdirs ld binutils gprof"
482 ;;
483 mips*-*-irix5*)
484 # The GNU linker does not support shared libraries.
485 # emacs is emacs 18, which does not work on Irix 5 (emacs19 does work)
486 noconfigdirs="$noconfigdirs ld gprof emacs"
487 ;;
488 mips*-dec-bsd*)
489 noconfigdirs="$noconfigdirs gprof"
490 ;;
491 mips*-*-bsd*)
492 noconfigdirs="$noconfigdirs gprof"
493 ;;
494 mips*-*-*)
495 noconfigdirs="$noconfigdirs gprof"
496 ;;
497 romp-*-*)
498 noconfigdirs="$noconfigdirs bfd binutils ld gas opcodes"
499 ;;
500 sh-*-*)
501 case "${host}" in
502 i[345]86-*-vsta) ;; # don't add gprof back in
503 i[345]86-*-go32) ;; # don't add gprof back in
504 *) skipdirs=`echo " ${skipdirs} " | sed -e 's/ gprof / /'` ;;
505 esac
506 ;;
507 sparc-*-sunos4*)
508 if [ x${is_cross_compiler} != xno ] ; then
509 noconfigdirs="$noconfigdirs gdb gdbtest target-newlib"
510 else
511 use_gnu_ld=no
512 fi
513 ;;
514 sparclet-*-*)
515 # Skip these until ready for them.
516 noconfigdirs="$noconfigdirs target-libg++ target-libstdc++ target-libio target-librx"
517 v810-*-*)
518 noconfigdirs="$noconfigdirs bfd binutils gas gcc gdb ld target-libio target-libg++ target-libstdc++ opcodes"
519 ;;
520 vax-*-vms)
521 noconfigdirs="$noconfigdirs bfd binutils gdb ld target-newlib opcodes"
522 ;;
523 vax-*-*)
524 noconfigdirs="$noconfigdirs target-newlib"
525 ;;
526 *-*-lynxos*)
527 # Newlib makes problems for libg++ in crosses.
528 noconfigdirs="$noconfigdirs target-newlib"
529 ;;
530 *-*-macos* | \
531 *-*-mpw*)
532 # Macs want a resource compiler.
533 configdirs="$configdirs grez"
534 ;;
535 esac
536
537 # targets that need a second pass
538 case "${target}" in
539 *-gm-magic*)
540 noconfigdirs="$noconfigdirs libgloss"
541 ;;
542 esac
543
544 # If we are building a Canadian Cross, discard tools that can not be built
545 # using a cross compiler. FIXME: These tools should be fixed.
546 if [ "${build}" != "${host}" ]; then
547 noconfigdirs="$noconfigdirs expect dejagnu make texinfo diff"
548 fi
549
550 # Make sure we don't let GNU ld be added if we didn't want it.
551 if [ x$with_gnu_ld = xno ]; then
552 use_gnu_ld=no
553 noconfigdirs="$noconfigdirs ld"
554 fi
555
556 # Make sure we don't let GNU as be added if we didn't want it.
557 if [ x$with_gnu_as = xno ]; then
558 use_gnu_as=no
559 noconfigdirs="$noconfigdirs gas"
560 fi
561
562 # Remove the entries in $skipdirs and $noconfigdirs from $configdirs and
563 # $target_configdirs.
564 # If we have the source for $noconfigdirs entries, add them to $notsupp.
565
566 notsupp=""
567 for dir in . $skipdirs $noconfigdirs ; do
568 dirname=`echo $dir | sed -e s/target-//g`
569 if [ $dir != . ] && echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
570 configdirs=`echo " ${configdirs} " | sed -e "s/ ${dir} / /"`
571 if [ -r $srcdir/$dirname/configure ] \
572 || [ -r $srcdir/$dirname/configure.in ]; then
573 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
574 true
575 else
576 notsupp="$notsupp $dir"
577 fi
578 fi
579 fi
580 if [ $dir != . ] && echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
581 target_configdirs=`echo " ${target_configdirs} " | sed -e "s/ ${dir} / /"`
582 if [ -r $srcdir/$dirname/configure ] \
583 || [ -r $srcdir/$dirname/configure.in ]; then
584 if echo " ${skipdirs} " | grep " ${dir} " >/dev/null 2>&1; then
585 true
586 else
587 notsupp="$notsupp $dir"
588 fi
589 fi
590 fi
591 done
592
593 # Sometimes the tools are distributed with libiberty but with no other
594 # libraries. In that case, we don't want to build target-libiberty.
595 if [ -n "${target_configdirs}" ]; then
596 others=
597 for i in `echo ${target_configdirs} | sed -e s/target-//g` ; do
598 if [ "$i" != "libiberty" ]; then
599 if [ -r $srcdir/$i/configure ] || [ -r $srcdir/$i/configure.in ]; then
600 others=yes;
601 break;
602 fi
603 fi
604 done
605 if [ -z "${others}" ]; then
606 target_configdirs=
607 fi
608 fi
609
610 # Deconfigure all subdirectories, in case we are changing the
611 # configuration from one where a subdirectory is supported to one where it
612 # is not.
613 if [ -z "${norecursion}" -a -n "${configdirs}" ]; then
614 for i in `echo ${configdirs} | sed -e s/target-//g` ; do
615 rm -f $i/Makefile
616 done
617 fi
618 if [ -z "${norecursion}" -a -n "${target_configdirs}" ]; then
619 for i in `echo ${target_configdirs} | sed -e s/target-//` ; do
620 rm -f ${target_subdir}/$i/Makefile
621 done
622 fi
623
624 # Produce a warning message for the subdirs we can't configure.
625 # This isn't especially interesting in the Cygnus tree, but in the individual
626 # FSF releases, it's important to let people know when their machine isn't
627 # supported by the one or two programs in a package.
628
629 if [ -n "${notsupp}" ] && [ -z "${norecursion}" ]; then
630 # If $appdirs is non-empty, at least one of those directories must still
631 # be configured, or we error out. (E.g., if the gas release supports a
632 # specified target in some subdirs but not the gas subdir, we shouldn't
633 # pretend that all is well.)
634 if [ -n "$appdirs" ]; then
635 for dir in $appdirs ; do
636 if [ -r $dir/Makefile.in ]; then
637 if echo " ${configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
638 appdirs=""
639 break
640 fi
641 if echo " ${target_configdirs} " | grep " ${dir} " >/dev/null 2>&1; then
642 appdirs=""
643 break
644 fi
645 fi
646 done
647 if [ -n "$appdirs" ]; then
648 echo "*** This configuration is not supported by this package." 1>&2
649 exit 1
650 fi
651 fi
652 # Okay, some application will build, or we don't care to check. Still
653 # notify of subdirs not getting built.
654 echo "*** This configuration is not supported in the following subdirectories:" 1>&2
655 echo " ${notsupp}" 1>&2
656 echo " (Any other directories should still work fine.)" 1>&2
657 fi
658
659 # Set with_gnu_as and with_gnu_ld as appropriate.
660 #
661 # This is done by determining whether or not the appropriate directory
662 # is available, and by checking whether or not specific configurations
663 # have requested that this magic not happen.
664 #
665 # The command line options always override the explicit settings in
666 # configure.in, and the settings in configure.in override this magic.
667 #
668 # If the default for a toolchain is to use GNU as and ld, and you don't
669 # want to do that, then you should use the --without-gnu-as and
670 # --without-gnu-ld options for the configure script.
671
672 if [ x${use_gnu_as} = x ] ; then
673 if [ x${with_gnu_as} != xno ] && echo " ${configdirs} " | grep " ${gasdir} " > /dev/null 2>&1 && [ -d ${srcdir}/${gasdir} ] ; then
674 with_gnu_as=yes
675 withoptions="$withoptions --with-gnu-as"
676 fi
677 fi
678
679 if [ x${use_gnu_ld} = x ] ; then
680 if [ x${with_gnu_ld} != xno ] && echo " ${configdirs} " | grep " ld " > /dev/null 2>&1 && [ -d ${srcdir}/ld ] ; then
681 with_gnu_ld=yes
682 withoptions="$withoptions --with-gnu-ld"
683 fi
684 fi
685
686 if [ x${enable_shared} = xyes ]; then
687 case "${target}" in
688 hppa*) target_makefile_frag=config/mt-papic ;;
689 i[345]86-*) target_makefile_frag=config/mt-x86pic ;;
690 *) target_makefile_frag=config/mt-${target_cpu}pic ;;
691 esac
692 fi
693
694 # post-target:
695
696 # Make sure that the compiler is able to generate an executable. If it
697 # can't, we are probably in trouble. We don't care whether we can run the
698 # executable--we might be using a cross compiler--we only care whether it
699 # can be created. At this point the main configure script has set CC.
700 echo "int main () { return 0; }" > conftest.c
701 ${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c
702 if [ $? = 0 ] && [ -s conftest ]; then
703 :
704 else
705 echo 1>&2 "*** The command '${CC} -o conftest ${CFLAGS} ${CPPFLAGS} ${LDFLAGS} conftest.c' failed."
706 echo 1>&2 "*** You must set the environment variable CC to a working compiler."
707 rm -f conftest*
708 exit 1
709 fi
710 rm -f conftest*
711
712 # If --enable-shared was set, we must set LD_LIBRARY_PATH so that the
713 # binutils tools will find libbfd.so.
714 if [ "${enable_shared}" = "yes" ]; then
715 sed -e 's/^SET_LIB_PATH[ ]*=.*$/SET_LIB_PATH = $(REALLY_SET_LIB_PATH)/' \
716 Makefile > Makefile.tem
717 rm -f Makefile
718 mv -f Makefile.tem Makefile
719 fi
720
721 # Record target_configdirs and the configure arguments in Makefile.
722 target_configdirs=`echo "${target_configdirs}" | sed -e 's/target-//g'`
723 targargs=`echo "${arguments}" | \
724 sed -e 's/--norecursion//' \
725 -e 's/--cache[a-z-]*=[^ ]*//' \
726 -e 's/--ho[a-z-]*=[^ ]*//' \
727 -e 's/--ta[a-z-]*=[^ ]*//'`
728
729 # Passing a --with-cross-host argument lets the target libraries know
730 # whether they are being built with a cross-compiler or being built
731 # native. However, it would be better to use other mechanisms to make the
732 # sorts of decisions they want to make on this basis. Please consider
733 # this option to be deprecated. FIXME.
734 if [ x${is_cross_compiler} = xyes ]; then
735 targargs="--with-cross-host=${host_alias} ${targargs}"
736 fi
737
738 targargs="--host=${target_alias} ${targargs}"
739 sed -e "s:^TARGET_CONFIGDIRS[ ]*=.*$:TARGET_CONFIGDIRS = ${target_configdirs}:" \
740 -e "s%^CONFIG_ARGUMENTS[ ]*=.*$%CONFIG_ARGUMENTS = ${targargs}%" \
741 -e "s%^TARGET_SUBDIR[ ]*=.*$%TARGET_SUBDIR = ${target_subdir}%" \
742 Makefile > Makefile.tem
743 rm -f Makefile
744 mv -f Makefile.tem Makefile
745
746 #
747 # Local Variables:
748 # fill-column: 131
749 # End:
750 #
This page took 0.045967 seconds and 5 git commands to generate.